// Automatically generated file. DO NOT EDIT.
// Generated by gen-device-avr.py from ATtiny20.atdf, see http://packs.download.atmel.com/

// +build avr,attiny20

// Device information for the ATtiny20.
package avr

import (
	"runtime/volatile"
	"unsafe"
)

// Special type that causes loads/stores to be volatile (necessary for
// memory-mapped registers).
type Register8 struct {
	Reg uint8
}

// Get returns the value in the register. It is the volatile equivalent of:
//
//     *r.Reg
//
//go:inline
func (r *Register8) Get() uint8 {
	return volatile.LoadUint8(&r.Reg)
}

// Set updates the register value. It is the volatile equivalent of:
//
//     *r.Reg = value
//
//go:inline
func (r *Register8) Set(value uint8) {
	volatile.StoreUint8(&r.Reg, value)
}

// SetBits reads the register, sets the given bits, and writes it back. It is
// the volatile equivalent of:
//
//     r.Reg |= value
//
//go:inline
func (r *Register8) SetBits(value uint8) {
	volatile.StoreUint8(&r.Reg, volatile.LoadUint8(&r.Reg)|value)
}

// ClearBits reads the register, clears the given bits, and writes it back. It
// is the volatile equivalent of:
//
//     r.Reg &^= value
//
//go:inline
func (r *Register8) ClearBits(value uint8) {
	volatile.StoreUint8(&r.Reg, volatile.LoadUint8(&r.Reg)&^value)
}

// HasBits reads the register and then checks to see if the passed bits are set. It
// is the volatile equivalent of:
//
//     (*r.Reg & value) > 0
//
//go:inline
func (r *Register8) HasBits(value uint8) bool {
	return (r.Get() & value) > 0
}

// Some information about this device.
const (
	DEVICE = "ATtiny20"
	ARCH   = "AVR8L"
	FAMILY = "tinyAVR"
)

// Interrupts
const (
	IRQ_RESET      = 0  // External Reset, Power-on Reset and Watchdog Reset
	IRQ_INT0       = 1  // External Interrupt Request 0
	IRQ_PCINT0     = 2  // Pin Change Interrupt Request 0
	IRQ_PCINT1     = 3  // Pin Change Interrupt Request 1
	IRQ_WDT        = 4  // Watchdog Time-out
	IRQ_TIM1_CAPT  = 5  // Timer/Counter1 Input Capture
	IRQ_TIM1_COMPA = 6  //  Timer/Counter1 Compare Match A
	IRQ_TIM1_COMPB = 7  //  Timer/Counter1 Compare Match B
	IRQ_TIM1_OVF   = 8  // Timer/Counter1 Overflow
	IRQ_TIM0_COMPA = 9  // Timer/Counter0 Compare Match A
	IRQ_TIM0_COMPB = 10 // Timer/Counter0 Compare Match B
	IRQ_TIM0_OVF   = 11 // Timer/Counter0 Overflow
	IRQ_ANA_COMP   = 12 // Analog Comparator
	IRQ_ADC_ADC    = 13 // Conversion Complete
	IRQ_TWI_SLAVE  = 14 // Two-Wire Interface
	IRQ_SPI        = 15 // Serial Peripheral Interface
	IRQ_QTRIP      = 16 // Touch Sensing
	IRQ_max        = 16 // Highest interrupt number on this device.
)

// Peripherals.
var (
	// Fuses
	BYTE0 = (*Register8)(unsafe.Pointer(uintptr(0x0)))

	// Lockbits
	LOCKBIT = (*Register8)(unsafe.Pointer(uintptr(0x0)))

	// I/O Port
	PUEB  = (*Register8)(unsafe.Pointer(uintptr(0x7)))
	DDRB  = (*Register8)(unsafe.Pointer(uintptr(0x5)))
	PINB  = (*Register8)(unsafe.Pointer(uintptr(0x4)))
	PORTB = (*Register8)(unsafe.Pointer(uintptr(0x6)))
	PUEA  = (*Register8)(unsafe.Pointer(uintptr(0x3)))
	PORTA = (*Register8)(unsafe.Pointer(uintptr(0x2)))
	DDRA  = (*Register8)(unsafe.Pointer(uintptr(0x1)))
	PINA  = (*Register8)(unsafe.Pointer(uintptr(0x0)))

	// Watchdog Timer
	WDTCSR = (*Register8)(unsafe.Pointer(uintptr(0x31)))

	// Analog-to-Digital Converter
	ADMUX  = (*Register8)(unsafe.Pointer(uintptr(0x10)))
	ADCSRA = (*Register8)(unsafe.Pointer(uintptr(0x12)))
	ADCL   = (*Register8)(unsafe.Pointer(uintptr(0xe)))
	ADCH   = (*Register8)(unsafe.Pointer(uintptr(0xf)))
	ADCSRB = (*Register8)(unsafe.Pointer(uintptr(0x11)))
	DIDR0  = (*Register8)(unsafe.Pointer(uintptr(0xd)))

	// Analog Comparator
	ACSRB = (*Register8)(unsafe.Pointer(uintptr(0x13)))
	ACSRA = (*Register8)(unsafe.Pointer(uintptr(0x14)))

	// CPU Registers
	CCP    = (*Register8)(unsafe.Pointer(uintptr(0x3c)))
	SPL    = (*Register8)(unsafe.Pointer(uintptr(0x3d)))
	SPH    = (*Register8)(unsafe.Pointer(uintptr(0x3e)))
	SREG   = (*Register8)(unsafe.Pointer(uintptr(0x3f)))
	CLKMSR = (*Register8)(unsafe.Pointer(uintptr(0x37)))
	CLKPSR = (*Register8)(unsafe.Pointer(uintptr(0x36)))
	OSCCAL = (*Register8)(unsafe.Pointer(uintptr(0x39)))
	PRR    = (*Register8)(unsafe.Pointer(uintptr(0x35)))
	RSTFLR = (*Register8)(unsafe.Pointer(uintptr(0x3b)))
	NVMCSR = (*Register8)(unsafe.Pointer(uintptr(0x32)))
	NVMCMD = (*Register8)(unsafe.Pointer(uintptr(0x33)))

	// External Interrupts
	PCMSK1 = (*Register8)(unsafe.Pointer(uintptr(0xa)))
	PCMSK0 = (*Register8)(unsafe.Pointer(uintptr(0x9)))
	GIFR   = (*Register8)(unsafe.Pointer(uintptr(0xb)))
	GIMSK  = (*Register8)(unsafe.Pointer(uintptr(0xc)))

	// Timer/Counter, 8-bit
	TCCR0A = (*Register8)(unsafe.Pointer(uintptr(0x19)))
	TCCR0B = (*Register8)(unsafe.Pointer(uintptr(0x18)))
	TCNT0  = (*Register8)(unsafe.Pointer(uintptr(0x17)))
	OCR0A  = (*Register8)(unsafe.Pointer(uintptr(0x16)))
	OCR0B  = (*Register8)(unsafe.Pointer(uintptr(0x15)))

	// Two Wire Serial Interface
	TWSCRA = (*Register8)(unsafe.Pointer(uintptr(0x2d)))
	TWSCRB = (*Register8)(unsafe.Pointer(uintptr(0x2c)))
	TWSSRA = (*Register8)(unsafe.Pointer(uintptr(0x2b)))
	TWSA   = (*Register8)(unsafe.Pointer(uintptr(0x2a)))
	TWSD   = (*Register8)(unsafe.Pointer(uintptr(0x28)))
	TWSAM  = (*Register8)(unsafe.Pointer(uintptr(0x29)))

	// Timer/Counter, 16-bit
	TCCR1A = (*Register8)(unsafe.Pointer(uintptr(0x24)))
	TCCR1B = (*Register8)(unsafe.Pointer(uintptr(0x23)))
	TCCR1C = (*Register8)(unsafe.Pointer(uintptr(0x22)))
	TCNT1L = (*Register8)(unsafe.Pointer(uintptr(0x20)))
	TCNT1H = (*Register8)(unsafe.Pointer(uintptr(0x21)))
	OCR1AL = (*Register8)(unsafe.Pointer(uintptr(0x1e)))
	OCR1AH = (*Register8)(unsafe.Pointer(uintptr(0x1f)))
	OCR1BL = (*Register8)(unsafe.Pointer(uintptr(0x1c)))
	OCR1BH = (*Register8)(unsafe.Pointer(uintptr(0x1d)))
	ICR1L  = (*Register8)(unsafe.Pointer(uintptr(0x1a)))
	ICR1H  = (*Register8)(unsafe.Pointer(uintptr(0x1b)))

	// Serial Peripheral Interface
	SPCR = (*Register8)(unsafe.Pointer(uintptr(0x30)))
	SPSR = (*Register8)(unsafe.Pointer(uintptr(0x2f)))
	SPDR = (*Register8)(unsafe.Pointer(uintptr(0x2e)))
)

// Bitfields for FUSE: Fuses
const (
	// BYTE0
	BYTE0_BODLEVEL0 = 0x10 // Brown-out Detector trigger level
	BYTE0_BODLEVEL1 = 0x20 // Brown-out Detector trigger level
	BYTE0_BODLEVEL2 = 0x40 // Brown-out Detector trigger level
	BYTE0_CKOUT     = 0x4  // Output external clock
	BYTE0_WDTON     = 0x2  // Watch dog timer always on
	BYTE0_RSTDISBL  = 0x1  // Disable external reset
)

// Bitfields for LOCKBIT: Lockbits
const (
	// LOCKBIT
	LOCKBIT_LB0 = 0x1 // Memory Lock
	LOCKBIT_LB1 = 0x2 // Memory Lock
)

// Bitfields for WDT: Watchdog Timer
const (
	// WDTCSR: Watchdog Timer Control and Status Register
	WDTCSR_WDIF = 0x80 // Watchdog Timer Interrupt Flag
	WDTCSR_WDIE = 0x40 // Watchdog Timer Interrupt Enable
	WDTCSR_WDP0 = 0x1  // Watchdog Timer Prescaler Bits
	WDTCSR_WDP1 = 0x2  // Watchdog Timer Prescaler Bits
	WDTCSR_WDP2 = 0x4  // Watchdog Timer Prescaler Bits
	WDTCSR_WDP3 = 0x20 // Watchdog Timer Prescaler Bits
	WDTCSR_WDE  = 0x8  // Watch Dog Enable
)

// Bitfields for ADC: Analog-to-Digital Converter
const (
	// ADMUX: The ADC multiplexer Selection Register
	ADMUX_REFS = 0x40 // Reference Selection Bit
	ADMUX_MUX0 = 0x1  // Analog Channel and Gain Selection Bits
	ADMUX_MUX1 = 0x2  // Analog Channel and Gain Selection Bits
	ADMUX_MUX2 = 0x4  // Analog Channel and Gain Selection Bits
	ADMUX_MUX3 = 0x8  // Analog Channel and Gain Selection Bits

	// ADCSRA: The ADC Control and Status register
	ADCSRA_ADEN  = 0x80 // ADC Enable
	ADCSRA_ADSC  = 0x40 // ADC Start Conversion
	ADCSRA_ADATE = 0x20 // ADC Auto Trigger Enable
	ADCSRA_ADIF  = 0x10 // ADC Interrupt Flag
	ADCSRA_ADIE  = 0x8  // ADC Interrupt Enable
	ADCSRA_ADPS0 = 0x1  // ADC Prescaler Select Bits
	ADCSRA_ADPS1 = 0x2  // ADC Prescaler Select Bits
	ADCSRA_ADPS2 = 0x4  // ADC Prescaler Select Bits

	// ADCSRB: ADC Control and Status Register B
	ADCSRB_ADLAR = 0x8
	ADCSRB_ADTS0 = 0x1 // ADC Auto Trigger Sources
	ADCSRB_ADTS1 = 0x2 // ADC Auto Trigger Sources
	ADCSRB_ADTS2 = 0x4 // ADC Auto Trigger Sources

	// DIDR0: Digital Input Disable Register 0
	DIDR0_ADC7D = 0x80 // ADC6 Digital input Disable
	DIDR0_ADC6D = 0x40 // ADC5 Digital input Disable
	DIDR0_ADC5D = 0x20 // ADC4 Digital input Disable
	DIDR0_ADC4D = 0x10 // ADC3 Digital input Disable
	DIDR0_ADC3D = 0x8  // AREF Digital Input Disable
	DIDR0_ADC2D = 0x4  // ADC2 Digital input Disable
	DIDR0_ADC1D = 0x2  // ADC1 Digital input Disable
	DIDR0_ADC0D = 0x1  // ADC0 Digital input Disable
)

// Bitfields for AC: Analog Comparator
const (
	// ACSRB: Analog Comparator Control And Status Register B
	ACSRB_HSEL = 0x80 // Hysteresis Select
	ACSRB_HLEV = 0x40 // Hysteresis Level
	ACSRB_ACME = 0x4  // Analog Comparator Multiplexer Enable

	// ACSRA: Analog Comparator Control And Status Register A
	ACSRA_ACD   = 0x80 // Analog Comparator Disable
	ACSRA_ACBG  = 0x40 // Analog Comparator Bandgap Select
	ACSRA_ACO   = 0x20 // Analog Compare Output
	ACSRA_ACI   = 0x10 // Analog Comparator Interrupt Flag
	ACSRA_ACIE  = 0x8  // Analog Comparator Interrupt Enable
	ACSRA_ACIC  = 0x4  // Analog Comparator Input Capture Enable
	ACSRA_ACIS0 = 0x1  // Analog Comparator Interrupt Mode Select bits
	ACSRA_ACIS1 = 0x2  // Analog Comparator Interrupt Mode Select bits
)

// Bitfields for CPU: CPU Registers
const (
	// SREG: Status Register
	SREG_I = 0x80 // Global Interrupt Enable
	SREG_T = 0x40 // Bit Copy Storage
	SREG_H = 0x20 // Half Carry Flag
	SREG_S = 0x10 // Sign Bit
	SREG_V = 0x8  // Two's Complement Overflow Flag
	SREG_N = 0x4  // Negative Flag
	SREG_Z = 0x2  // Zero Flag
	SREG_C = 0x1  // Carry Flag

	// CLKMSR: Clock Main Settings Register
	CLKMSR_CLKMS0 = 0x1 // Clock Main Select Bits
	CLKMSR_CLKMS1 = 0x2 // Clock Main Select Bits

	// CLKPSR: Clock Prescale Register
	CLKPSR_CLKPS0 = 0x1 // Clock Prescaler Select Bits
	CLKPSR_CLKPS1 = 0x2 // Clock Prescaler Select Bits
	CLKPSR_CLKPS2 = 0x4 // Clock Prescaler Select Bits
	CLKPSR_CLKPS3 = 0x8 // Clock Prescaler Select Bits

	// OSCCAL: Oscillator Calibration Value
	OSCCAL_OSCCAL0 = 0x1  // Oscillator Calibration
	OSCCAL_OSCCAL1 = 0x2  // Oscillator Calibration
	OSCCAL_OSCCAL2 = 0x4  // Oscillator Calibration
	OSCCAL_OSCCAL3 = 0x8  // Oscillator Calibration
	OSCCAL_OSCCAL4 = 0x10 // Oscillator Calibration
	OSCCAL_OSCCAL5 = 0x20 // Oscillator Calibration
	OSCCAL_OSCCAL6 = 0x40 // Oscillator Calibration
	OSCCAL_OSCCAL7 = 0x80 // Oscillator Calibration

	// PRR: Power Reduction Register
	PRR_PRTWI  = 0x10 // Power Reduction TWI
	PRR_PRSPI  = 0x8  // Power Reduction Serial Peripheral Interface
	PRR_PRTIM1 = 0x4  // Power Reduction Timer/Counter1
	PRR_PRTIM0 = 0x2  // Power Reduction Timer/Counter0
	PRR_PRADC  = 0x1  // Power Reduction ADC

	// RSTFLR: Reset Flag Register
	RSTFLR_WDRF  = 0x8 // Watchdog Reset Flag
	RSTFLR_EXTRF = 0x2 // External Reset Flag
	RSTFLR_PORF  = 0x1 // Power-on Reset Flag

	// NVMCSR: Non-Volatile Memory Control and Status Register
	NVMCSR_NVMBSY = 0x80 // Non-Volatile Memory Busy
)

// Bitfields for EXINT: External Interrupts
const (
	// PCMSK1: Pin Change Mask Register 1
	PCMSK1_PCINT0 = 0x1 // Pin Change Enable Masks
	PCMSK1_PCINT1 = 0x2 // Pin Change Enable Masks
	PCMSK1_PCINT2 = 0x4 // Pin Change Enable Masks
	PCMSK1_PCINT3 = 0x8 // Pin Change Enable Masks

	// PCMSK0: Pin Change Mask Register 0
	PCMSK0_PCINT0 = 0x1  // Pin Change Enable Masks
	PCMSK0_PCINT1 = 0x2  // Pin Change Enable Masks
	PCMSK0_PCINT2 = 0x4  // Pin Change Enable Masks
	PCMSK0_PCINT3 = 0x8  // Pin Change Enable Masks
	PCMSK0_PCINT4 = 0x10 // Pin Change Enable Masks
	PCMSK0_PCINT5 = 0x20 // Pin Change Enable Masks
	PCMSK0_PCINT6 = 0x40 // Pin Change Enable Masks
	PCMSK0_PCINT7 = 0x80 // Pin Change Enable Masks

	// GIFR: General Interrupt Flag Register
	GIFR_PCIF0 = 0x10 // Pin Change Interrupt Flags
	GIFR_PCIF1 = 0x20 // Pin Change Interrupt Flags
	GIFR_INTF0 = 0x1  // External Interrupt Flag 0

	// GIMSK: General Interrupt Mask Register
	GIMSK_PCIE0 = 0x10 // Pin Change Interrupt Enables
	GIMSK_PCIE1 = 0x20 // Pin Change Interrupt Enables
	GIMSK_INT0  = 0x1  // External Interrupt Request 0 Enable
)

// Bitfields for TC8: Timer/Counter, 8-bit
const (
	// TCCR0A: Timer/Counter 0 Control Register A
	TCCR0A_COM0A0 = 0x40 // Compare Output Mode for Channel A bits
	TCCR0A_COM0A1 = 0x80 // Compare Output Mode for Channel A bits
	TCCR0A_COM0B0 = 0x10 // Compare Output Mode for Channel B bits
	TCCR0A_COM0B1 = 0x20 // Compare Output Mode for Channel B bits
	TCCR0A_WGM00  = 0x1  // Waveform Generation Mode
	TCCR0A_WGM01  = 0x2  // Waveform Generation Mode

	// TCCR0B: Timer/Counter 0 Control Register B
	TCCR0B_FOC0A = 0x80 // Force Output Compare A
	TCCR0B_FOC0B = 0x40 // Force Output Compare B
	TCCR0B_WGM02 = 0x8  // Waveform Generation Mode
	TCCR0B_CS00  = 0x1  // Clock Select
	TCCR0B_CS01  = 0x2  // Clock Select
	TCCR0B_CS02  = 0x4  // Clock Select
)

// Bitfields for TWI: Two Wire Serial Interface
const (
	// TWSCRA: TWI Slave Control Register A
	TWSCRA_TWSHE  = 0x80 // TWI SDA Hold Time Enable
	TWSCRA_TWDIE  = 0x20 // TWI Data Interrupt Enable
	TWSCRA_TWASIE = 0x10 // TWI Address/Stop Interrupt Enable
	TWSCRA_TWEN   = 0x8  // Two-Wire Interface Enable
	TWSCRA_TWSIE  = 0x4  // TWI Stop Interrupt Enable
	TWSCRA_TWPME  = 0x2  // TWI Promiscuous Mode Enable
	TWSCRA_TWSME  = 0x1  // TWI Smart Mode Enable

	// TWSCRB: TWI Slave Control Register B
	TWSCRB_TWAA   = 0x4 // TWI Acknowledge Action
	TWSCRB_TWCMD0 = 0x1
	TWSCRB_TWCMD1 = 0x2

	// TWSA: TWI Slave Address Register
	TWSA_TWSA0 = 0x1  // TWI slave address bit
	TWSA_TWSA1 = 0x2  // TWI slave address bit
	TWSA_TWSA2 = 0x4  // TWI slave address bit
	TWSA_TWSA3 = 0x8  // TWI slave address bit
	TWSA_TWSA4 = 0x10 // TWI slave address bit
	TWSA_TWSA5 = 0x20 // TWI slave address bit
	TWSA_TWSA6 = 0x40 // TWI slave address bit
	TWSA_TWSA7 = 0x80 // TWI slave address bit

	// TWSD: TWI Slave Data Register
	TWSD_TWSD0 = 0x1  // TWI slave data bit
	TWSD_TWSD1 = 0x2  // TWI slave data bit
	TWSD_TWSD2 = 0x4  // TWI slave data bit
	TWSD_TWSD3 = 0x8  // TWI slave data bit
	TWSD_TWSD4 = 0x10 // TWI slave data bit
	TWSD_TWSD5 = 0x20 // TWI slave data bit
	TWSD_TWSD6 = 0x40 // TWI slave data bit
	TWSD_TWSD7 = 0x80 // TWI slave data bit
)

// Bitfields for TC16: Timer/Counter, 16-bit
const (
	// TCCR1A: Timer/Counter1 Control Register A
	TCCR1A_COM1A0 = 0x40 // Compare Output Mode 1A, bits
	TCCR1A_COM1A1 = 0x80 // Compare Output Mode 1A, bits
	TCCR1A_COM1B0 = 0x10 // Compare Output Mode 1B, bits
	TCCR1A_COM1B1 = 0x20 // Compare Output Mode 1B, bits
	TCCR1A_WGM10  = 0x1  // Waveform Generation Mode Bits
	TCCR1A_WGM11  = 0x2  // Waveform Generation Mode Bits

	// TCCR1B: Timer/Counter1 Control Register B
	TCCR1B_ICNC1 = 0x80 // Input Capture 1 Noise Canceler
	TCCR1B_ICES1 = 0x40 // Input Capture 1 Edge Select
	TCCR1B_WGM10 = 0x8  // Waveform Generation Mode
	TCCR1B_WGM11 = 0x10 // Waveform Generation Mode
	TCCR1B_CS10  = 0x1  // Clock Select1 bits
	TCCR1B_CS11  = 0x2  // Clock Select1 bits
	TCCR1B_CS12  = 0x4  // Clock Select1 bits

	// TCCR1C: Timer/Counter1 Control Register C
	TCCR1C_FOC1A = 0x80 // Force Output Compare for channel A
	TCCR1C_FOC1B = 0x40 // Force Output Compare for channel B
)

// Bitfields for SPI: Serial Peripheral Interface
const (
	// SPCR: SPI Control Register
	SPCR_SPIE = 0x80 // SPI Interrupt Enable
	SPCR_SPE  = 0x40 // SPI Enable
	SPCR_DORD = 0x20 // Data Order
	SPCR_MSTR = 0x10 // Master/Slave Select
	SPCR_CPOL = 0x8  // Clock polarity
	SPCR_CPHA = 0x4  // Clock Phase
	SPCR_SPR0 = 0x1  // SPI Clock Rate Selects
	SPCR_SPR1 = 0x2  // SPI Clock Rate Selects

	// SPSR: SPI Status Register
	SPSR_SPIF  = 0x80 // SPI Interrupt Flag
	SPSR_WCOL  = 0x40 // Write Collision Flag
	SPSR_SPI2X = 0x1  // Double SPI Speed Bit
)
