// Automatically generated file. DO NOT EDIT.
// Generated by gen-device-avr.py from ATtiny2313.atdf, see http://packs.download.atmel.com/

// +build avr,attiny2313

// Device information for the ATtiny2313.
package avr

import (
	"runtime/volatile"
	"unsafe"
)

// Special type that causes loads/stores to be volatile (necessary for
// memory-mapped registers).
type Register8 struct {
	Reg uint8
}

// Get returns the value in the register. It is the volatile equivalent of:
//
//     *r.Reg
//
//go:inline
func (r *Register8) Get() uint8 {
	return volatile.LoadUint8(&r.Reg)
}

// Set updates the register value. It is the volatile equivalent of:
//
//     *r.Reg = value
//
//go:inline
func (r *Register8) Set(value uint8) {
	volatile.StoreUint8(&r.Reg, value)
}

// SetBits reads the register, sets the given bits, and writes it back. It is
// the volatile equivalent of:
//
//     r.Reg |= value
//
//go:inline
func (r *Register8) SetBits(value uint8) {
	volatile.StoreUint8(&r.Reg, volatile.LoadUint8(&r.Reg)|value)
}

// ClearBits reads the register, clears the given bits, and writes it back. It
// is the volatile equivalent of:
//
//     r.Reg &^= value
//
//go:inline
func (r *Register8) ClearBits(value uint8) {
	volatile.StoreUint8(&r.Reg, volatile.LoadUint8(&r.Reg)&^value)
}

// HasBits reads the register and then checks to see if the passed bits are set. It
// is the volatile equivalent of:
//
//     (*r.Reg & value) > 0
//
//go:inline
func (r *Register8) HasBits(value uint8) bool {
	return (r.Get() & value) > 0
}

// Some information about this device.
const (
	DEVICE = "ATtiny2313"
	ARCH   = "AVR8"
	FAMILY = "tinyAVR"
)

// Interrupts
const (
	IRQ_RESET        = 0  // External Reset, Power-on Reset and Watchdog Reset
	IRQ_INT0         = 1  // External Interrupt Request 0
	IRQ_INT1         = 2  // External Interrupt Request 1
	IRQ_TIMER1_CAPT  = 3  // Timer/Counter1 Capture Event
	IRQ_TIMER1_COMPA = 4  // Timer/Counter1 Compare Match A
	IRQ_TIMER1_OVF   = 5  // Timer/Counter1 Overflow
	IRQ_TIMER0_OVF   = 6  // Timer/Counter0 Overflow
	IRQ_USART_RX     = 7  // USART, Rx Complete
	IRQ_USART_UDRE   = 8  // USART Data Register Empty
	IRQ_USART_TX     = 9  // USART, Tx Complete
	IRQ_ANA_COMP     = 10 // Analog Comparator
	IRQ_PCINT        = 11 //
	IRQ_TIMER1_COMPB = 12 //
	IRQ_TIMER0_COMPA = 13 //
	IRQ_TIMER0_COMPB = 14 //
	IRQ_USI_START    = 15 // USI Start Condition
	IRQ_USI_OVERFLOW = 16 // USI Overflow
	IRQ_EEPROM_Ready = 17 //
	IRQ_WDT_OVERFLOW = 18 // Watchdog Timer Overflow
	IRQ_max          = 18 // Highest interrupt number on this device.
)

// Peripherals.
var (
	// Fuses
	EXTENDED = (*Register8)(unsafe.Pointer(uintptr(0x2)))
	HIGH     = (*Register8)(unsafe.Pointer(uintptr(0x1)))
	LOW      = (*Register8)(unsafe.Pointer(uintptr(0x0)))

	// Lockbits
	LOCKBIT = (*Register8)(unsafe.Pointer(uintptr(0x0)))

	// I/O Port
	PORTB = (*Register8)(unsafe.Pointer(uintptr(0x38)))
	DDRB  = (*Register8)(unsafe.Pointer(uintptr(0x37)))
	PINB  = (*Register8)(unsafe.Pointer(uintptr(0x36)))
	PORTD = (*Register8)(unsafe.Pointer(uintptr(0x32)))
	DDRD  = (*Register8)(unsafe.Pointer(uintptr(0x31)))
	PIND  = (*Register8)(unsafe.Pointer(uintptr(0x30)))
	PORTA = (*Register8)(unsafe.Pointer(uintptr(0x3b)))
	DDRA  = (*Register8)(unsafe.Pointer(uintptr(0x3a)))
	PINA  = (*Register8)(unsafe.Pointer(uintptr(0x39)))

	// Timer/Counter, 8-bit
	OCR0B  = (*Register8)(unsafe.Pointer(uintptr(0x5c)))
	OCR0A  = (*Register8)(unsafe.Pointer(uintptr(0x56)))
	TCCR0A = (*Register8)(unsafe.Pointer(uintptr(0x50)))
	TCNT0  = (*Register8)(unsafe.Pointer(uintptr(0x52)))
	TCCR0B = (*Register8)(unsafe.Pointer(uintptr(0x53)))

	// Timer/Counter, 16-bit
	TCCR1A = (*Register8)(unsafe.Pointer(uintptr(0x4f)))
	TCCR1B = (*Register8)(unsafe.Pointer(uintptr(0x4e)))
	TCCR1C = (*Register8)(unsafe.Pointer(uintptr(0x42)))
	TCNT1L = (*Register8)(unsafe.Pointer(uintptr(0x4c)))
	TCNT1H = (*Register8)(unsafe.Pointer(uintptr(0x4d)))
	OCR1AL = (*Register8)(unsafe.Pointer(uintptr(0x4a)))
	OCR1AH = (*Register8)(unsafe.Pointer(uintptr(0x4b)))
	OCR1BL = (*Register8)(unsafe.Pointer(uintptr(0x48)))
	OCR1BH = (*Register8)(unsafe.Pointer(uintptr(0x49)))
	ICR1L  = (*Register8)(unsafe.Pointer(uintptr(0x44)))
	ICR1H  = (*Register8)(unsafe.Pointer(uintptr(0x45)))

	// Watchdog Timer
	WDTCR = (*Register8)(unsafe.Pointer(uintptr(0x41)))

	// External Interrupts
	GIMSK = (*Register8)(unsafe.Pointer(uintptr(0x5b)))
	EIFR  = (*Register8)(unsafe.Pointer(uintptr(0x5a)))

	// USART
	UDR   = (*Register8)(unsafe.Pointer(uintptr(0x2c)))
	UCSRA = (*Register8)(unsafe.Pointer(uintptr(0x2b)))
	UCSRB = (*Register8)(unsafe.Pointer(uintptr(0x2a)))
	UCSRC = (*Register8)(unsafe.Pointer(uintptr(0x23)))
	UBRRH = (*Register8)(unsafe.Pointer(uintptr(0x22)))
	UBRRL = (*Register8)(unsafe.Pointer(uintptr(0x29)))

	// Analog Comparator
	ACSR = (*Register8)(unsafe.Pointer(uintptr(0x28)))
	DIDR = (*Register8)(unsafe.Pointer(uintptr(0x21)))

	// EEPROM
	EEAR = (*Register8)(unsafe.Pointer(uintptr(0x3e)))
	EEDR = (*Register8)(unsafe.Pointer(uintptr(0x3d)))
	EECR = (*Register8)(unsafe.Pointer(uintptr(0x3c)))

	// CPU Registers
	SREG   = (*Register8)(unsafe.Pointer(uintptr(0x5f)))
	SPL    = (*Register8)(unsafe.Pointer(uintptr(0x5d)))
	SPMCSR = (*Register8)(unsafe.Pointer(uintptr(0x57)))
	MCUCR  = (*Register8)(unsafe.Pointer(uintptr(0x55)))
	MCUSR  = (*Register8)(unsafe.Pointer(uintptr(0x54)))
	OSCCAL = (*Register8)(unsafe.Pointer(uintptr(0x51)))
	CLKPR  = (*Register8)(unsafe.Pointer(uintptr(0x46)))
	GTCCR  = (*Register8)(unsafe.Pointer(uintptr(0x43)))
	PCMSK  = (*Register8)(unsafe.Pointer(uintptr(0x40)))
	GPIOR2 = (*Register8)(unsafe.Pointer(uintptr(0x35)))
	GPIOR1 = (*Register8)(unsafe.Pointer(uintptr(0x34)))
	GPIOR0 = (*Register8)(unsafe.Pointer(uintptr(0x33)))

	// Universal Serial Interface
	USIDR = (*Register8)(unsafe.Pointer(uintptr(0x2f)))
	USISR = (*Register8)(unsafe.Pointer(uintptr(0x2e)))
	USICR = (*Register8)(unsafe.Pointer(uintptr(0x2d)))
)

// Bitfields for FUSE: Fuses
const (
	// EXTENDED
	EXTENDED_SELFPRGEN = 0x1 // Self Programming enable

	// HIGH
	HIGH_DWEN      = 0x80 // Debug Wire enable
	HIGH_EESAVE    = 0x40 // Preserve EEPROM through the Chip Erase cycle
	HIGH_SPIEN     = 0x20 // Serial program downloading (SPI) enable
	HIGH_WDTON     = 0x10 // Watch-dog Timer always on
	HIGH_BODLEVEL0 = 0x2  // Brown-out Detector trigger level
	HIGH_BODLEVEL1 = 0x4  // Brown-out Detector trigger level
	HIGH_BODLEVEL2 = 0x8  // Brown-out Detector trigger level
	HIGH_RSTDISBL  = 0x1  // External reset disable

	// LOW
	LOW_CKDIV8     = 0x80 // Divide clock by 8 internally
	LOW_CKOUT      = 0x40 // Clock output on PORTD2
	LOW_SUT_CKSEL0 = 0x1  // Select Clock Source
	LOW_SUT_CKSEL1 = 0x2  // Select Clock Source
	LOW_SUT_CKSEL2 = 0x4  // Select Clock Source
	LOW_SUT_CKSEL3 = 0x8  // Select Clock Source
	LOW_SUT_CKSEL4 = 0x10 // Select Clock Source
	LOW_SUT_CKSEL5 = 0x20 // Select Clock Source
)

// Bitfields for LOCKBIT: Lockbits
const (
	// LOCKBIT
	LOCKBIT_LB0 = 0x1 // Memory Lock
	LOCKBIT_LB1 = 0x2 // Memory Lock
)

// Bitfields for TC8: Timer/Counter, 8-bit
const (
	// TCCR0A: Timer/Counter  Control Register A
	TCCR0A_COM0A0 = 0x40 // Compare Match Output A Mode
	TCCR0A_COM0A1 = 0x80 // Compare Match Output A Mode
	TCCR0A_COM0B0 = 0x10 // Compare Match Output B Mode
	TCCR0A_COM0B1 = 0x20 // Compare Match Output B Mode
	TCCR0A_WGM00  = 0x1  // Waveform Generation Mode
	TCCR0A_WGM01  = 0x2  // Waveform Generation Mode

	// TCCR0B: Timer/Counter Control Register B
	TCCR0B_FOC0A = 0x80 // Force Output Compare B
	TCCR0B_FOC0B = 0x40 // Force Output Compare B
	TCCR0B_WGM02 = 0x8
	TCCR0B_CS00  = 0x1 // Clock Select
	TCCR0B_CS01  = 0x2 // Clock Select
	TCCR0B_CS02  = 0x4 // Clock Select
)

// Bitfields for TC16: Timer/Counter, 16-bit
const (
	// TCCR1A: Timer/Counter1 Control Register A
	TCCR1A_COM1A0 = 0x40 // Compare Output Mode 1A, bits
	TCCR1A_COM1A1 = 0x80 // Compare Output Mode 1A, bits
	TCCR1A_COM1B0 = 0x10 // Compare Output Mode 1B, bits
	TCCR1A_COM1B1 = 0x20 // Compare Output Mode 1B, bits
	TCCR1A_WGM10  = 0x1  // Pulse Width Modulator Select Bits
	TCCR1A_WGM11  = 0x2  // Pulse Width Modulator Select Bits

	// TCCR1B: Timer/Counter1 Control Register B
	TCCR1B_ICNC1 = 0x80 // Input Capture 1 Noise Canceler
	TCCR1B_ICES1 = 0x40 // Input Capture 1 Edge Select
	TCCR1B_WGM10 = 0x8  // Waveform Generation Mode Bits
	TCCR1B_WGM11 = 0x10 // Waveform Generation Mode Bits
	TCCR1B_CS10  = 0x1  // Clock Select1 bits
	TCCR1B_CS11  = 0x2  // Clock Select1 bits
	TCCR1B_CS12  = 0x4  // Clock Select1 bits

	// TCCR1C: Timer/Counter1 Control Register C
	TCCR1C_FOC1A = 0x80 // Force Output Compare for Channel A
	TCCR1C_FOC1B = 0x40 // Force Output Compare for Channel B
)

// Bitfields for WDT: Watchdog Timer
const (
	// WDTCR: Watchdog Timer Control Register
	WDTCR_WDIF = 0x80 // Watchdog Timeout Interrupt Flag
	WDTCR_WDIE = 0x40 // Watchdog Timeout Interrupt Enable
	WDTCR_WDP0 = 0x1  // Watchdog Timer Prescaler Bits
	WDTCR_WDP1 = 0x2  // Watchdog Timer Prescaler Bits
	WDTCR_WDP2 = 0x4  // Watchdog Timer Prescaler Bits
	WDTCR_WDP3 = 0x20 // Watchdog Timer Prescaler Bits
	WDTCR_WDCE = 0x10 // Watchdog Change Enable
	WDTCR_WDE  = 0x8  // Watch Dog Enable
)

// Bitfields for EXINT: External Interrupts
const (
	// GIMSK: General Interrupt Mask Register
	GIMSK_INT0 = 0x40 // External Interrupt Request 1 Enable
	GIMSK_INT1 = 0x80 // External Interrupt Request 1 Enable
	GIMSK_PCIE = 0x20

	// EIFR: Extended Interrupt Flag Register
	EIFR_INTF0 = 0x40 // External Interrupt Flags
	EIFR_INTF1 = 0x80 // External Interrupt Flags
	EIFR_PCIF  = 0x20
)

// Bitfields for USART: USART
const (
	// UCSRA: USART Control and Status Register A
	UCSRA_RXC  = 0x80 // USART Receive Complete
	UCSRA_TXC  = 0x40 // USART Transmitt Complete
	UCSRA_UDRE = 0x20 // USART Data Register Empty
	UCSRA_FE   = 0x10 // Framing Error
	UCSRA_DOR  = 0x8  // Data overRun
	UCSRA_UPE  = 0x4  // USART Parity Error
	UCSRA_U2X  = 0x2  // Double the USART Transmission Speed
	UCSRA_MPCM = 0x1  // Multi-processor Communication Mode

	// UCSRB: USART Control and Status Register B
	UCSRB_RXCIE = 0x80 // RX Complete Interrupt Enable
	UCSRB_TXCIE = 0x40 // TX Complete Interrupt Enable
	UCSRB_UDRIE = 0x20 // USART Data register Empty Interrupt Enable
	UCSRB_RXEN  = 0x10 // Receiver Enable
	UCSRB_TXEN  = 0x8  // Transmitter Enable
	UCSRB_UCSZ2 = 0x4  // Character Size
	UCSRB_RXB8  = 0x2  // Receive Data Bit 8
	UCSRB_TXB8  = 0x1  // Transmit Data Bit 8

	// UCSRC: USART Control and Status Register C
	UCSRC_UMSEL = 0x40 // USART Mode Select
	UCSRC_UPM0  = 0x10 // Parity Mode Bits
	UCSRC_UPM1  = 0x20 // Parity Mode Bits
	UCSRC_USBS  = 0x8  // Stop Bit Select
	UCSRC_UCSZ0 = 0x2  // Character Size Bits
	UCSRC_UCSZ1 = 0x4  // Character Size Bits
	UCSRC_UCPOL = 0x1  // Clock Polarity
)

// Bitfields for AC: Analog Comparator
const (
	// ACSR: Analog Comparator Control And Status Register
	ACSR_ACD   = 0x80 // Analog Comparator Disable
	ACSR_ACBG  = 0x40 // Analog Comparator Bandgap Select
	ACSR_ACO   = 0x20 // Analog Compare Output
	ACSR_ACI   = 0x10 // Analog Comparator Interrupt Flag
	ACSR_ACIE  = 0x8  // Analog Comparator Interrupt Enable
	ACSR_ACIC  = 0x4
	ACSR_ACIS0 = 0x1 // Analog Comparator Interrupt Mode Select bits
	ACSR_ACIS1 = 0x2 // Analog Comparator Interrupt Mode Select bits
)

// Bitfields for EEPROM: EEPROM
const (
	// EECR: EEPROM Control Register
	EECR_EEPM0 = 0x10
	EECR_EEPM1 = 0x20
	EECR_EERIE = 0x8 // EEProm Ready Interrupt Enable
	EECR_EEMPE = 0x4 // EEPROM Master Write Enable
	EECR_EEPE  = 0x2 // EEPROM Write Enable
	EECR_EERE  = 0x1 // EEPROM Read Enable
)

// Bitfields for CPU: CPU Registers
const (
	// SREG: Status Register
	SREG_I = 0x80 // Global Interrupt Enable
	SREG_T = 0x40 // Bit Copy Storage
	SREG_H = 0x20 // Half Carry Flag
	SREG_S = 0x10 // Sign Bit
	SREG_V = 0x8  // Two's Complement Overflow Flag
	SREG_N = 0x4  // Negative Flag
	SREG_Z = 0x2  // Zero Flag
	SREG_C = 0x1  // Carry Flag

	// SPMCSR: Store Program Memory Control and Status register
	SPMCSR_CTPB  = 0x10 // Clear Temporary Page Buffer
	SPMCSR_RFLB  = 0x8  // Read Fuse and Lock Bits
	SPMCSR_PGWRT = 0x4  // Page Write
	SPMCSR_PGERS = 0x2  // Page Erase
	SPMCSR_SPMEN = 0x1  // Store Program Memory Enable

	// MCUCR: MCU Control Register
	MCUCR_PUD   = 0x80 // Pull-up Disable
	MCUCR_SM0   = 0x10 // Sleep Mode Select Bits
	MCUCR_SM1   = 0x40 // Sleep Mode Select Bits
	MCUCR_SE    = 0x20 // Sleep Enable
	MCUCR_ISC10 = 0x4  // Interrupt Sense Control 1 bits
	MCUCR_ISC11 = 0x8  // Interrupt Sense Control 1 bits
	MCUCR_ISC00 = 0x1  // Interrupt Sense Control 0 bits
	MCUCR_ISC01 = 0x2  // Interrupt Sense Control 0 bits

	// MCUSR: MCU Status register
	MCUSR_WDRF  = 0x8 // Watchdog Reset Flag
	MCUSR_BORF  = 0x4 // Brown-out Reset Flag
	MCUSR_EXTRF = 0x2 // External Reset Flag
	MCUSR_PORF  = 0x1 // Power-On Reset Flag

	// OSCCAL: Oscillator Calibration Register
	OSCCAL_OSCCAL0 = 0x1  // Oscillator Calibration
	OSCCAL_OSCCAL1 = 0x2  // Oscillator Calibration
	OSCCAL_OSCCAL2 = 0x4  // Oscillator Calibration
	OSCCAL_OSCCAL3 = 0x8  // Oscillator Calibration
	OSCCAL_OSCCAL4 = 0x10 // Oscillator Calibration
	OSCCAL_OSCCAL5 = 0x20 // Oscillator Calibration
	OSCCAL_OSCCAL6 = 0x40 // Oscillator Calibration
	OSCCAL_OSCCAL7 = 0x80 // Oscillator Calibration

	// CLKPR: Clock Prescale Register
	CLKPR_CLKPCE = 0x80 // Clock Prescaler Change Enable
	CLKPR_CLKPS0 = 0x1  // Clock Prescaler Select Bits
	CLKPR_CLKPS1 = 0x2  // Clock Prescaler Select Bits
	CLKPR_CLKPS2 = 0x4  // Clock Prescaler Select Bits
	CLKPR_CLKPS3 = 0x8  // Clock Prescaler Select Bits

	// GTCCR: General Timer Counter Control Register
	GTCCR_PSR10 = 0x1
)

// Bitfields for USI: Universal Serial Interface
const (
	// USISR: USI Status Register
	USISR_USISIF  = 0x80 // Start Condition Interrupt Flag
	USISR_USIOIF  = 0x40 // Counter Overflow Interrupt Flag
	USISR_USIPF   = 0x20 // Stop Condition Flag
	USISR_USIDC   = 0x10 // Data Output Collision
	USISR_USICNT0 = 0x1  // USI Counter Value Bits
	USISR_USICNT1 = 0x2  // USI Counter Value Bits
	USISR_USICNT2 = 0x4  // USI Counter Value Bits
	USISR_USICNT3 = 0x8  // USI Counter Value Bits

	// USICR: USI Control Register
	USICR_USISIE = 0x80 // Start Condition Interrupt Enable
	USICR_USIOIE = 0x40 // Counter Overflow Interrupt Enable
	USICR_USIWM0 = 0x10 // USI Wire Mode Bits
	USICR_USIWM1 = 0x20 // USI Wire Mode Bits
	USICR_USICS0 = 0x4  // USI Clock Source Select Bits
	USICR_USICS1 = 0x8  // USI Clock Source Select Bits
	USICR_USICLK = 0x2  // Clock Strobe
	USICR_USITC  = 0x1  // Toggle Clock Port Pin
)
